package com.usk.youtubeplugin.plugins;

import android.app.Activity;
import android.content.Intent;


import com.usk.youtubeplugin.PlayerActivity;

import io.flutter.plugin.common.EventChannel;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.PluginRegistry;

public class YoutubePlugin implements MethodChannel.MethodCallHandler, EventChannel.StreamHandler {

    private static final String STREAM_CHANNEL_NAME = "USKAPP/flutter_youtube_stream";
    private static final int YOUTUBE_PLAYER_RESULT = 6646;

    Activity activity;
    static EventChannel.EventSink events;

    YoutubePlugin(Activity act) {
        activity = act;
    }
    /**
     * Plugin registration.
     */
    public static void registerWith(PluginRegistry.Registrar registrar) {
        final MethodChannel channel = new MethodChannel(registrar.messenger(), "USKAPP/flutter_youtube");
        channel.setMethodCallHandler(new YoutubePlugin(registrar.activity()));
        registrar.addActivityResultListener(new PluginRegistry.ActivityResultListener() {
            @Override
            public boolean onActivityResult(int i, int i1, Intent intent) {
                if(i == YOUTUBE_PLAYER_RESULT) {
                    if(intent != null) {
                        if(intent.getIntExtra("done", -1) == 0) {
                            if(events != null) {
                                events.success("done");
                            }
                        }
                    }
                }
                return false;
            }
        });

        final EventChannel eventChannel = new EventChannel(registrar.messenger(), STREAM_CHANNEL_NAME);
        YoutubePlugin youtubeWithEventChannel = new YoutubePlugin(registrar.activity());
        eventChannel.setStreamHandler(youtubeWithEventChannel);
    }

    @Override
    public void onMethodCall(MethodCall call, MethodChannel.Result result) {

        if (call.method.equals("playYoutubeVideo")) {

            String videoId = call.argument("id");
            boolean autoPlay = call.argument("autoPlay");
            boolean fullScreen = call.argument("fullScreen");
            boolean appBarVisible = call.argument("appBarVisible");
            Long appBarColor = call.argument("appBarColor");
            Long backgroundColor = call.argument("backgroundColor");


            Intent playerIntent = new Intent(activity, PlayerActivity.class);

            playerIntent.putExtra("videoId", videoId);
            playerIntent.putExtra("autoPlay", autoPlay);
            playerIntent.putExtra("fullScreen", fullScreen);
            playerIntent.putExtra("appBarVisible", appBarVisible);
            playerIntent.putExtra("appBarColor", appBarColor.intValue());
            playerIntent.putExtra("backgroundColor", backgroundColor.intValue());

            activity.startActivityForResult(playerIntent, YOUTUBE_PLAYER_RESULT);

        } else {
            result.notImplemented();
        }
    }

    @Override
    public void onListen(Object o, EventChannel.EventSink eventSink) {
        events = eventSink;
    }

    @Override
    public void onCancel(Object o) {
        events = null;
    }
}